#include <stdio.h>
#include <stdlib.h>

int strlen_r(char *s){
    if (*s=='\0') return 0;
    return 1 + strlen_r(&s[1]);
}

int palindroma(char *s){
    int i, res, l=strlen_r(s);
    char *r;
    printf("\"%s\"\n",s);
    if (s[0]!=s[l-1]) return 0;
    if (l==0) return 1;
    r=malloc(sizeof(char)*(l-1));
    for(i=1; i<l-1; i++)
        r[i-1]=s[i];
    r[l-1]='\0';
    res = palindroma(r);
    free(r);
    return res;
}

int main(int argc, char **argv){
    char *s;
    if (argc>1) {
        s=argv[1];
        printf("len(%s)=%d\n", s, strlen_r(s));
        printf("%s palindroma? %d\n", s, palindroma(s));
    }
}
